Last Comment Bug 742672 - GCLI needs a new home
: GCLI needs a new home
Status: RESOLVED FIXED
[fixed-in-fx-team]
:
Product: Firefox
Classification: Client Software
Component: Developer Tools: Console (show other bugs)
: unspecified
: All All
: P2 normal (vote)
: Firefox 15
Assigned To: Joe Walker [:jwalker] (needinfo me or ping on irc)
:
:
Mentors:
Depends on: 758819
Blocks: 745773 749397
  Show dependency treegraph
 
Reported: 2012-04-05 03:31 PDT by Joe Walker [:jwalker] (needinfo me or ping on irc)
Modified: 2012-05-25 15:30 PDT (History)
2 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Upload 1 (632.57 KB, patch)
2012-05-09 11:27 PDT, Joe Walker [:jwalker] (needinfo me or ping on irc)
no flags Details | Diff | Splinter Review
Upload 2 (201.33 KB, patch)
2012-05-15 13:26 PDT, Joe Walker [:jwalker] (needinfo me or ping on irc)
rcampbell: review+
Details | Diff | Splinter Review
Upload 3 (199.50 KB, patch)
2012-05-17 09:53 PDT, Joe Walker [:jwalker] (needinfo me or ping on irc)
no flags Details | Diff | Splinter Review

Description Joe Walker [:jwalker] (needinfo me or ping on irc) 2012-04-05 03:31:11 PDT
Currently GCLI lives in various files in 'webconsole', but this is an articfact of history because it is now used entirely by the developer toolbar in 'shared', and not by anything in 'webconsole'.

I propose a new devtools/gcli directory.

At the same time we should:
- Use devtools/gcli/generated for files from the GCLI project
  I think this directory would contain 3 files (probably) for GCLI modules
  The point of the separation is to make it clearer which files have an
  external source
- Split console.js out so it doesn't have to be duplicated
- Split the module loader out so it doesn't have to be duplicated
  (both of these probably should live in 'shared')
- Split gcli.jsm into:
  - devtools/gcli/gcli.jsm ('public' interface for devtools)
  - devtools/gcli/generated/common-modules.jsm (imported modules, see above)
- Move command-loading from DeveloperToolbar to gcli.jsm
- Work to get as many firefox resources out of gcli and into central
Comment 1 Joe Walker [:jwalker] (needinfo me or ping on irc) 2012-05-09 11:27:13 PDT
Created attachment 622427 [details] [diff] [review]
Upload 1

Rob - there's a ton of stuff here, I'm happy to talk it through with you - I think that would probably save lots of time.
Comment 2 Joe Walker [:jwalker] (needinfo me or ping on irc) 2012-05-09 11:29:58 PDT
Some additional context for this move:
- I'd like to take any breaking changes for the GCLI API now rather than later
  If moving things around could break commands then we want to do this now.
- The NetPanel import depends on the files we split out here.
Comment 3 Dave Camp (:dcamp) 2012-05-09 11:36:33 PDT
Can we call the directory 'commandline' so that people have a chance of finding it without knowing our esoteric name for the command line?
Comment 4 Rob Campbell [:rc] (:robcee) 2012-05-10 09:20:41 PDT
(In reply to Dave Camp (:dcamp) from comment #3)
> Can we call the directory 'commandline' so that people have a chance of
> finding it without knowing our esoteric name for the command line?

sensible.
Comment 5 Joe Walker [:jwalker] (needinfo me or ping on irc) 2012-05-15 13:26:31 PDT
Created attachment 624166 [details] [diff] [review]
Upload 2

Fixes known issues
Comment 6 Joe Walker [:jwalker] (needinfo me or ping on irc) 2012-05-15 23:56:50 PDT
https://tbpl.mozilla.org/?tree=Try&rev=5e93d67dc98d
Comment 7 Rob Campbell [:rc] (:robcee) 2012-05-16 11:24:57 PDT
Comment on attachment 624166 [details] [diff] [review]
Upload 2

per discussion in IRC.
Comment 8 Joe Walker [:jwalker] (needinfo me or ping on irc) 2012-05-17 09:53:02 PDT
Created attachment 624786 [details] [diff] [review]
Upload 3


Fixes Rob's comments from IRC:
- License header was incorrectly standard Firefox header, changed back to reflect
  gcli license.
- Gcli.jsm vs GCLI.jsm: I left it as it originally was gcli.jsm
  I think the lowercase.jsm for imported modules we discussed originally makes
  lots of sense. Lets stick with that.

Also:
https://tbpl.mozilla.org/?tree=Try&rev=247f6c538eb3
Comment 9 Joe Walker [:jwalker] (needinfo me or ping on irc) 2012-05-17 11:10:32 PDT
https://tbpl.mozilla.org/?tree=Fx-Team&rev=985058b05905
Comment 10 Ed Morley [:emorley] 2012-05-21 01:56:00 PDT
https://hg.mozilla.org/mozilla-central/rev/985058b05905

Note You need to log in before you can comment on or make changes to this bug.